
## if given fileName is not available then it throws FileNotFoundError
'''
print('start line')

open('demo.txt', "r")

print('end line')
'''

## if given fileName is available then it creates file Object
'''
print('start line')

fileObject = open('demo.txt', "r")
print(fileObject)
print("File Name is :",fileObject.name)
print("File Mode is :",fileObject.mode)
print(fileObject.closed)
print('end line')
'''

## How to access the fileData using fileObject?
'''
fileObject = open('demo.txt', "r")

for i in fileObject:
    print(i, end="\n")
'''

# What is output?
'''
fileObject = open('demo.txt', "r")

for i in fileObject:
    print(i, end="")

'''

### working with "read()"  method
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data)  
'''

## How to return list of words and total words count using given file ?
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data.split())
print("Totally",len(data.split()),"words available")
'''

## How to return list of lines and total lines count using given file ?
'''
fileObject = open('demo.txt', "r")

data = fileObject.read() ## returns like "multiline string"
print(data.splitlines())
print("Totally",len(data.splitlines()),"lines available")
'''

## Shortest way
'''
print(open('demo.txt', "r").read())

print(open('demo.txt', "r").read().split())

print(len(open('demo.txt', "r").read().split()))
'''


## read(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.read(4) # it returns only given count number of charecters.
print(data)

data2 = fileObject.read() 
print(data2)
'''

## realine()
'''
fileObject = open('demo.txt', "r")

data = fileObject.readline() # it returns current line from file pointer position
print(data, end="")
'''

## realine(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.readline(4) #
print(data)

data = fileObject.readline() #
print(data, end="")
'''

##  readlines()
'''
fileObject = open('demo.txt', "r")

data = fileObject.readlines() # it returns list of lines 
print(data)
'''
## Shortest way
'''
print(open('demo.txt', "r").readlines())

print(len(open('demo.txt', "r").readlines()))
'''

##  readlines(count)
'''
fileObject = open('demo.txt', "r")

data = fileObject.readlines(2) # it returns list of current single line 
print(data)
'''

## How to accesss the last line last word  first charecter
'''
print(open('demo.txt', "r").readlines()[-1].split()[-1][0])
'''

## if fileObject is closed then if traying to access the data from a file then it throws below exception
# ValueError: I/O operation on closed file.
'''
fileObject = open('demo.txt', "r")

data = fileObject.read(4)
print(data)

fileObject.close()
print(fileObject.read(4)) # ValueError: I/O operation on closed file.
'''

###
#### Writting the data into a file  #####
###


### working with "w"  mode ###

## if given fileName is not available then it creates new file
'''
print('start line')

fileObject = open('demo2.txt', 'w')

print(fileObject)

print('end line')
'''

## if given fileName is already available then it truncates it and creates new file
'''
print('start line')

fileObject = open('demo3.txt', 'w')

print(fileObject)

print('end line')
'''

## if fileObject is not closing then we can not see the data in a file
'''
print('start line')

fileObject = open('demo4.txt', 'w')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
print('Data added in a file successfully!')

print('end line')
'''

## if fileObject is closing after adding data then we can see the data in a file
'''
print('start line')

fileObject = open('demo5.txt', 'w')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

##
### working with "x" (exclusive)  mode ###
##


## if given fileName is not available then it will creates it and we can add data
'''
print('start line')

fileObject = open('demo6.txt', 'x')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

## if given fileName is already available then it will throws exception like FileExistsError]
'''
print('start line')

fileObject = open('demo6.txt', 'x')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''


##
### working with "a" (append)  mode ###
##


## if given fileName is not available then it will creates it and we can add data
'''
print('start line')

fileObject = open('demo7.txt', 'a')

fileObject.write("Django is a Python web framework\nUsing Django Web applications can develop")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''

## if given fileName is already available then it will use same file and adding new data at end position
'''
print('start line')

fileObject = open('demo7.txt', 'a')

fileObject.write("\nDjango is follows MVT architecture")
fileObject.close()

print('Data added in a file successfully!')

print('end line')
'''



### Identify the Output

## if any exception raised before closing the fileObject then we are unable to see the data in a file
'''
print('start line')

fileObject = open('demo8.txt', 'w')

fileObject.write("\nDjango is follows MVT architecture")
print('Data added in a file successfully!')

x = 10
y = 0
z = x / y 

fileObject.close()

print('end line')
'''

## How to overcome the above proble ?

# Note:  by using "with" keyword if open the fileName and creating fileObject.
'''
print('start line')

with open('demo9.txt', 'w') as fileObject:
    fileObject.write("Django is follows MVT architecture")
    print('Data added in a file successfully!')

x = 10
y = 0
z = x / y 

fileObject.close()

print('end line')
'''

## Write a program to Counting number of vowels in the file ?
'''
fileObject = open('demo.txt', "r")
data = fileObject.read()

vowels = 'aeiouAEIOU'
count = 0
for i in data:
    if i in vowels:
        count = count + 1
        
print(count)       
'''

## finding each vowel count?
'''
fileObject = open('demo.txt', "r")
data = fileObject.read()

vowels = 'aeiouAEIOU'
vowels_dict = {}

for i in data:
    if i in vowels:
        if i not in vowels_dict:
            vowels_dict[i] = 1
        else:
            vowels_dict[i] = vowels_dict[i] + 1
            
print(vowels_dict)
'''

### working with "tell()" and "seek()"  methods
'''
fileObject = open('demo.txt', "r")
print("Initially File pointer position is :",fileObject.tell())

data = fileObject.read(4)
print(data)
print("Aftert accessing data, file pointer position is :",fileObject.tell())

fileObject.seek(0)
print("Aftert using seek(), file pointer position is :",fileObject.tell())

data = fileObject.read(4)
print(data)
'''


#####  Working with  predefined "os"  module #####

## getcwd()
'''
import os
print(os.getcwd())
'''

## listdir()
'''
import os
print(os.listdir())
'''

## rename("old_fileName1", "new_fileName2")

# if given old fileName is available then it renames with given new fileName
'''
import os
os.rename('sample1.txt', 'sample2.txt')
print('file name renamed successfully!')
'''

# if given old fileName is not available then it throws exception like FileNotFoundError
'''
import os
os.rename('sample3.txt', 'sample2.txt')
print('file name renamed successfully!')
'''

## remove('fileName')

# if given fileName is not available then it throws exception like FileNotFoundError
'''
import os
os.remove('sample3.txt')
print('file removed successfully!')
'''

# if given fileName is available then it will delete it
'''
import os
os.remove('sample2.txt')
print('file removed successfully!')
'''

## mkdir(path)

# if given folderName not available then it will create it
'''
import os
os.mkdir('Database')
print('Folder name created successfully!')
'''

## if given folderName is available then it will throws exception like FileExistsError
'''
import os
os.mkdir('Database')
print('Folder name created successfully!')
'''


## chdir(path)
'''
import os

print(os.getcwd())

os.chdir('Database')
print('Directory changed successfully')

print(os.getcwd())
'''

## rmdir(path)

# if given folderName is available then it will deleted
'''
import os

print(os.getcwd())

os.rmdir('Database')
print('Folder name deleted successfully!')
'''

#if given folderName is not available then it will throws exception like FileNotFoundError
'''
import os

print(os.getcwd())

os.rmdir('Database')
print('Folder name deleted successfully!')
'''

## How to identify the Parent directory of Currect directory ?
'''
import os
print(os.getcwd())

os.chdir("Django")
print('directory changed into Django Folder successfully!')
print(os.getcwd())

os.chdir(os.pardir)
print('Changed to Parent directory')
print(os.getcwd())
'''

## os.path.isfile(path) , os.path.isdir(path)
'''
import os
print(os.path.isfile('C:\Python@7PM\Files\demo.txt')) # True
print(os.path.isfile('C:\Python@7PM\Files')) # False

print(os.path.isdir('C:\Python@7PM\Files\demo.txt')) # False
print(os.path.isdir('C:\Python@7PM\Files')) # True
'''

## working with basename(), dirname(), join(), split()
'''
import os

print(os.path.basename('C:\Python@7PM\Files\demo.txt')) # demo.txt

print(os.path.dirname('C:\Python@7PM\Files\demo.txt')) # C:\Python@7PM\Files

print(os.path.join('C:\Python@7PM\Files', 'demo.txt')) # C:\Python@7PM\Files\demo.txt

print(os.path.split('C:\Python@7PM\Files\demo.txt')) # ('C:\\Python@7PM\\Files', 'demo.txt')
'''

## os.path.exists(path)
'''
import os

print(os.path.exists("C:\\Python@7PM\\Files\\demo.txt")) # True

print(os.path.exists("C:\\Python@7PM\\Files\\Sample\\demo.txt")) # False
'''

## Identify the output using  os.listdir()?
'''
import os
print(os.getcwd())

print(os.listdir())
'''

## Identify the output using  os.walk(path)?
'''
import os
print(os.getcwd())
print()

generator_object = os.walk('C:\Python@7PM\Files')

#print(generator_object)

for dirpathname, dirname, filename in generator_object: # ((pathName, dirnames, filenames),(---))
    print(dirpathname)
    print(dirname)
    print(filename)
    print()
'''


##  os.makedirs(path)
'''
import os
print(os.getcwd())

os.makedirs('C:\Python@7PM\python\Files')
print('Directory path creating')
'''

####  ===========   json  module  ============  #####

## How to converting python type data into json type data ?
'''
import json

dict_object = {
    'eno' : 101,
    'ename' : "Virat",
    "salary" : 10000,
}

json_object = json.dumps(dict_object)

print(json_object)

print(type(json_object))
'''


## How to converting json type data into python type data ?
"""
import json

json_object = '''{
    "eno" : 101,
    "ename" : "Virat",
    "salary" : 10000
}'''


python_object = json.loads(json_object)

print(python_object)

print(type(python_object))
"""



## How to converting python type data into json type data and load into json file?
'''
import json

dict_object = {
    'eno' : 101,
    'ename' : "Virat",
    "salary" : 10000,
}

json_object = json.dumps(dict_object)

with open('employee.json', 'w') as fileObject:
    fileObject.write(json_object)

print('Data is loaded in json file')
'''

## How to accessing json data from a json file and converting into python type data?
'''
import json

fileObject = open('employee.json', 'r')

data = fileObject.read()

python_data = json.loads(data)

print(python_data)
print(type(python_data))
'''

##
'''
import json

fileObject = open('employee.json', 'r')

python_data = json.load(fileObject)

print(python_data)
print(type(python_data))
'''

## What is differences between loads() and load() 

## What is differences between dumps() and dump()


## Identify the python dataypes and json datatypes
'''
python         json
======         ====
int, float   ---  number
str          ---  string
True, False  ---  true , false
None         ---  null
list, tuple  ---  array
dict         ---  object

set          --- not allowed
'''

## Converting Python type data into JSON type data using dumps() method
'''
import json
print(json.dumps('Hello'))
print(json.dumps(True))
print(json.dumps(False))
print(json.dumps(None))
print(json.dumps([10,20,30]))
print(json.dumps((10,20,30)))
#print(json.dumps({10,20,30})) # TypeError: Object of type set is not JSON serializable
print(json.dumps({1:10, 'eno':101,"ename":"Rohit",}))
print()
'''

## Converting JSON type data into Python type data  using loads() method
'''
print(json.loads('true'))
print(json.loads('false'))
print(json.loads('null'))
print(json.loads('10'))
print(json.loads('10.20'))
print(json.loads('"hello"'))
print(json.loads('[10,20,30]'))
print(json.loads('{"age":35, "city":"hyd"}'))
'''








